mavenproject1/src/main/java/org/blueqbit/sbjsf/model/ContactType.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.blueqbit.sbjsf.model;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import lombok.Data;

/**
 *
 * @author aaw
 */
@Entity
@Data
public class ContactType implements Serializable {
    
 
    @Id
    @Column(name="contact_type_id")
    private Long contactTypeId;
    
    private String contactName;
    
    public ContactType() {
        
    }
    
    public ContactType(Long ctId, String ctName) {
        contactTypeId = ctId;
        contactName = ctName;
    }
}

mavenproject1/src/main/java/org/blueqbit/sbjsf/model/Feedback.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.blueqbit.sbjsf.model;
import java.sql.Timestamp;
import javax.persistence.Column;
import lombok.Data;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.validation.constraints.Size;



/**
 *
 * @author aaw
 */
@Entity
@Data
public class Feedback {
    @Id
    @GeneratedValue
    private Long feedbackId;
    
    @Size(max=100)
    @Column(length = 100)
    private String name;
    
    @Size(max=100)
    @Column(length = 100)
    private String email;
    
   
    @ManyToOne(fetch=FetchType.EAGER)
    @JoinColumn(name="contact_type_id")
    private ContactType  contactType;
    
    @Size(max=1000)
    @Column(length = 1000)
    private String message;
    
    private Timestamp submissionTimestamp;
    
   
    
}

mavenproject1/src/main/java/org/blueqbit/sbjsf/controller/ContactTypeController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.blueqbit.sbjsf.controller;

/**
 *
 * @author aaw
 */
import org.springframework.beans.factory.annotation.Autowired;

import javax.faces.view.ViewScoped;
import javax.inject.Named;

import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import org.blueqbit.sbjsf.model.ContactType;

import org.blueqbit.sbjsf.repository.ContactTypeRepository;


@Named
@ViewScoped
public class ContactTypeController {

    private List<ContactType> contactTypes = new ArrayList<>();
    private ContactTypeRepository contactTypeRepository;
    
    @Autowired
    public ContactTypeController(ContactTypeRepository ctp) {
        contactTypeRepository = ctp;
    }
    
    public  List<ContactType> fetchAll() {
        contactTypes = contactTypeRepository.findAll();
        if (contactTypes == null) {
            contactTypes = new ArrayList<>();
        }  
        return contactTypes;
    }
    
    public List<SelectItem> getAllContactTypes() {
        List<SelectItem> items = new ArrayList<>();
        fetchAll().forEach(ct -> {
            items.add(new SelectItem(ct.getContactTypeId(), ct.getContactName()));
        });
        return items;
    }
    
    public List<String> getContactTypeNames() {
        List<String> retVal = new ArrayList<>();
        fetchAll().forEach(ct -> {
            retVal.add(ct.getContactName());
        });
        return retVal;
    }
    
}

mavenproject1/src/main/java/org/blueqbit/sbjsf/controller/FeedbackController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.blueqbit.sbjsf.controller;

/**
 *
 * @author aaw
 */
import org.springframework.beans.factory.annotation.Autowired;

import javax.faces.view.ViewScoped;
import javax.inject.Named;

import java.sql.Timestamp;
import java.time.Instant;
import java.util.List;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import org.blueqbit.sbjsf.model.ContactType;

import org.blueqbit.sbjsf.model.Feedback;
import org.blueqbit.sbjsf.repository.ContactTypeRepository;
import org.blueqbit.sbjsf.repository.FeedbackRepository;

@Named
@ViewScoped
public class FeedbackController {
    private Feedback feedback;
    private List<Feedback> allFeedbacks;
    private List<Feedback> filteredFeedbacks;
    
    private FeedbackRepository feedbackRepository;
    private ContactTypeRepository contactTypeRepository;
    
    
    public FeedbackController() {
        feedback = createEmptyFeedback();
        this.feedbackRepository = feedbackRepository;
        this.contactTypeRepository =  contactTypeRepository;
    }
    
    
    
  

    @Autowired
    public FeedbackController(FeedbackRepository feedbackRepository, ContactTypeRepository contactTypeRepository) {
        feedback = createEmptyFeedback();
        this.feedbackRepository = feedbackRepository;
        this.contactTypeRepository =  contactTypeRepository;
    }
    
    public void save() {
        FacesContext context = FacesContext.getCurrentInstance();
        ContactType ct = contactTypeRepository.findById(feedback.getContactType().getContactTypeId().longValue());
        feedback.setContactType(ct);
        feedback.setSubmissionTimestamp(Timestamp.from(Instant.now()));
        feedbackRepository.save(feedback);    
        feedback = createEmptyFeedback(); 
        context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,  "Success",  "Your feedback successfully stored") );
    }
    
    public Feedback getFeedback() {
        return feedback;
    }
    public void setFeedback(Feedback fb) {
        feedback = fb;
    }
    
    public List<Feedback> getAllFeedbacks() {
        fetchAll();
        return allFeedbacks;
    }
    public void setAllFeedback(List<Feedback> fbs) {
        allFeedbacks = fbs;
    }
    
    private Feedback createEmptyFeedback() {
        Feedback fb = new Feedback();
        fb.setContactType(new ContactType());
        return fb;
    }
    
    public void fetchAll() {
        allFeedbacks = feedbackRepository.findAll();
    }
    
    public List<Feedback> getFilteredFeedbacks() {
        return filteredFeedbacks;
    }
    public void setFilteredFeedbacks(List<Feedback> fbs) {
        filteredFeedbacks = fbs;
    }
    
}

mavenproject1/src/main/webapp/admin.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui">

    <h:head>
        <title>Admin feedback form</title>
    </h:head>
    <h:body>
        <style type="text/css">
            .ui-filter-column .ui-column-customfilter .custom-filter {
                width: 100%;
                box-sizing: border-box;
            }
        </style>
        <h:form>
            <p:panel>
                <f:facet name="header">
                    Feedbacks
                    <p:commandButton action="#{feedbackController.fetchAll()}"
                                     icon="pi pi-refresh" update="@form" process="@this"
                                     oncomplete="PF('feedbackTable').filter()"/>
                </f:facet>
                <p:dataTable var="feedback" value="#{feedbackController.allFeedbacks}"
                             rows="2" paginator="true" paginatorAlwaysVisible="true"
                             widgetVar="feedbackTable" filteredValue="#{feedbackController.filteredFeedbacks}">

                    <p:column headerText="Id" width="10%" sortBy="">
                        <h:outputText value="#{feedback.feedbackId}"/>
                    </p:column>


                    <p:column headerText="Date of submission" sortBy="#{feedback.submissionTimestamp}">
                        <h:outputText value="#{feedback.submissionTimestamp}">
                            <f:convertDateTime pattern="yyyy-MM-dd hh:mm:ss"/>
                        </h:outputText>
                    </p:column>

                    <p:column headerText="Name">
                        <h:outputText value="#{feedback.name}"/>
                    </p:column>

                    <p:column headerText="Email">
                        <h:outputText value="#{feedback.email}"/>
                    </p:column>

                    <p:column headerText="Contact type" filterBy="#{feedback.contactType.contactName}" filterMatchMode="exact">
                        <f:facet name="filter">
                            <p:selectOneMenu onchange="PF('feedbackTable').filter()" styleClass="custom-filter">
                                <f:selectItem itemLabel="Select One" itemValue="#{null}" noSelectionOption="true" />
                                <f:selectItems value="#{contactTypeController.contactTypeNames}" />
                            </p:selectOneMenu>
                        </f:facet>
                        <h:outputText value="#{feedback.contactType.contactName}"/>
                    </p:column>



                    <p:column headerText="Message">
                        <h:outputText value="#{feedback.message}" 
                        style="display:block;"/>
                        
                    </p:column>
                    <p:column headerText="Options" width="10%">
                        do something
                    </p:column>

                </p:dataTable>
            </p:panel>
        </h:form>
    </h:body>
</html>    

mavenproject1/src/main/webapp/feedback.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui">

    <h:head>
        <title>Provide feedback</title>
    </h:head>
    <h:body>
        <h:form>
            <p:messages id="messages" showDetail="true" closable="true">
                <p:autoUpdate />
            </p:messages>
            <p:panel>
                <f:facet name="header">
                    Enter Feedback

                </f:facet>

                <h:panelGrid columns="4">
                    <p:outputLabel id="nameLabel" value="Name:"/>
                    <p:tooltip id="toolTipNameLabel" for="nameLabel" value="Please enter your name"
                                showEffect="clip" hideEffect="explode" position="right"/>
                    <p:inputText id="name" value="#{feedbackController.feedback.name}" maxlength="100">
                        <f:validateRegex pattern="^[a-zA-Z0-9][a-zA-Z0-9' ]*[a-zA-Z0-9]$" />
                    </p:inputText>
                    
                    <p:message for="name" />

                    <p:outputLabel id="emailLabel" value="Email:"/>
                    <p:tooltip id="toolTipEmailLabel" for="emailLabel" value="Please enter your email is mandatory"
                                showEffect="clip" hideEffect="explode" position="right"/>
                    
                    <p:inputText id="email" value="#{feedbackController.feedback.email}" maxlength="100"
                                 requiredMessage="Please enter your email address."
                                 validatorMessage="Invalid email format"
                                 required="true">
                        <f:validateRegex
                            pattern="^[_A-Za-z0-9-\+]+(\.[_A-Za-z0-9-]+)*@[A-Za-z0-9-]+(\.[A-Za-z0-9]+)*(\.[A-Za-z]{2,})$" />

                    </p:inputText>    
                    <p:message for="email" />

                    <p:outputLabel id="contactTypeLabel" value="Contact type"/>
                    <p:tooltip id="toolTipContactTypeLabel" for="contactTypeLabel" value="Please choice your contact type"
                                showEffect="clip" hideEffect="explode" position="right"/>
                    <p:selectOneMenu id="contactTypeId" value="#{feedbackController.feedback.contactType.contactTypeId}">
                        <f:selectItems value="#{contactTypeController.allContactTypes}"/>
                    </p:selectOneMenu>
                    <p:message for="contactTypeId" />

                    <p:outputLabel id="messageLabel" value="Message"/>
                    <p:tooltip id="toolTipMessageLabel" for="messageLabel" value="Please enter your message (max 1000 chars)"
                                showEffect="clip" hideEffect="explode" position="right"/>
                    <p:inputTextarea id="message" value="#{feedbackController.feedback.message}"
                                     autoResize="false" 
                                     requiredMessage="Please enter message."
                                     required="true" rows="10" cols="50" maxlength="1000"
                                     style="resize: none">
                        
                    </p:inputTextarea>
                    <p:message for="message" />


                    
                    <p:commandButton value="Save" validateClient="true"  action="#{feedbackController.save()}"
                                     update="@form"  />



                </h:panelGrid>

            </p:panel> 
        </h:form>
    </h:body>
</html>    